import * as React from 'react';
import { PropsWithChildren } from 'react';
interface Auth {
    authenticated: boolean;
    lastPingResult: any | null;
    setAuthenticated(tf: boolean): void;
    forcePing(): void;
}
export declare function AuthProvider(props: PropsWithChildren<{
    onPing?: () => Promise<any>;
    pingInterval?: number;
}>): React.JSX.Element;
export declare function useAuthenticated(): Auth;
export {};
