import { AsyncResult } from './AsyncUtils';
import React from 'react';
export declare function ListAndDetailViewEditor<T>(props: {
    list: AsyncResult<T[]>;
    idExtractor: (item: T) => any;
    displayName: (item: T) => string;
    searchFields: (item: T) => string[];
    detail: (props: {
        item: T;
        onReload: () => void;
    }) => JSX.Element | null;
    create: (props: {
        onCancel: () => void;
        onComplete: (id: any) => void;
    }) => JSX.Element | null;
}): React.JSX.Element;
