import React from 'react';
import { FormObj } from './TForm';
interface Props {
    value: string;
    onChange(value: any): void;
}
type UserForm<T> = {
    update(key: keyof T, value: any): void;
};
export type UserChangeCallback<T> = (value: any, form: UserForm<T>) => void;
export declare function TFormValue<T extends FormObj>(props: {
    obj: T;
    objKey: keyof T;
    label?: string;
    noBottomMargin?: boolean;
    debounce?: number;
    onChange?: UserChangeCallback<T>;
    displayValue?: (input: any) => JSX.Element;
    children: (p: Props) => JSX.Element;
}): React.JSX.Element;
export {};
