"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSelect = TSelect;
var React = __importStar(require("react"));
var TFormValue_1 = require("./TFormValue");
var ArrayUtils_1 = require("../ArrayUtils");
var material_1 = require("@mui/material");
function TSelect(props) {
    return (React.createElement(TFormValue_1.TFormValue, { obj: props.obj, objKey: props.objKey, label: props.label, onChange: props.onChange, displayValue: function (e) {
            if (props.displayValue) {
                return props.displayValue(e);
            }
            var match = (0, ArrayUtils_1.first)(props.children, function (c) { return c.props.value === e; });
            if (!match)
                return '';
            return match.props.children;
        } }, function (p) { return (React.createElement(material_1.FormControl, { style: Object.assign({ marginBottom: 4 }, props.style), variant: props.variant || 'filled', fullWidth: true },
        React.createElement(material_1.InputLabel, { style: props.variant === 'outlined' ? { backgroundColor: 'white' } : undefined, variant: props.variant || 'filled', required: props.required, shrink: true }, props.label),
        React.createElement(material_1.Select, { disabled: props.disabled, required: props.required, value: p.value, onChange: function (event) {
                p.onChange(event.target.value);
            } }, props.children))); }));
}
