import React from 'react';
import { FormObj } from './TForm';
export declare function TTextField<T extends FormObj>(props: {
    label?: string;
    objKey: keyof T;
    obj: T;
    placeholder?: string;
    noBottomMargin?: boolean;
    disabled?: boolean;
    phone?: boolean;
    email?: boolean;
    required?: boolean;
    password?: boolean;
    width?: string;
}): React.JSX.Element;
