import React from 'react';
interface UElement {
    id: number;
    name: string;
}
export declare function UAutoComplete(props: {
    fetcher: (opt: {
        search: string;
    }) => Promise<UElement[]>;
    fetcherDeps?: any[];
    initialValue?: UElement;
    label: string;
    required?: boolean;
    type?: 'outlined' | 'standard';
    autoFocus?: boolean;
    className?: string;
    noBottomPadding?: boolean;
    shrinkLabel?: boolean;
    freeSolo?: boolean;
    disabled?: boolean;
    clearOnFocus?: boolean;
    onCancel?(): void;
    onKeyDown?(e: KeyboardEvent): void;
    onChange(value: UElement): void;
}): React.JSX.Element;
export {};
