import { Fetcher } from './Fetcher';
import { EventEmitter } from './EventEmitter';
export declare class APIBase {
    fetcher: Fetcher;
    onRefresh: EventEmitter<any>;
    constructor(options?: APIBaseOptions);
}
export interface APIBaseOptions {
    jwtRefreshEndpoint?: string;
    apiVersion?: string;
}
export declare const notAuthorizedResponse: EventEmitter<unknown>;
