import { ErrResponse } from './Fetcher';
type CallbackWithInput2<T, I> = (input: I) => Promise<T | ErrResponse>;
export type AsyncResult2<T> = {
    LoadingElement: JSX.Element | null;
    NoResultElement: JSX.Element | null;
    LoadingOrErrorElement: JSX.Element | null;
    loadingOrError: boolean;
    loading: boolean;
    error: string | null;
    result: T | null;
    asList: T;
    reload: () => void;
};
export declare function useAsync2<T, I>(fx: CallbackWithInput2<T, I>, search: I, searchDeps?: any[]): AsyncResult2<T>;
export {};
