"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRefreshOnInterval = useRefreshOnInterval;
var react_1 = require("react");
function useRefreshOnInterval(ms) {
    var _a = (0, react_1.useState)(false), value = _a[0], setValue = _a[1];
    (0, react_1.useEffect)(function () {
        var interval = setInterval(function () { return setValue(function (old) { return !old; }); }, ms);
        return function () { return clearInterval(interval); };
    }, [ms]);
}
