import * as React from 'react';
import { UserChangeCallback } from './TFormValue';
import { FormObj } from './TForm';
export declare function TSelect<T extends FormObj>(props: {
    style?: React.CSSProperties;
    label: string;
    obj: T;
    objKey: keyof T;
    onChange?: UserChangeCallback<T>;
    children: JSX.Element[];
    disabled?: boolean;
    variant?: 'filled' | 'outlined';
    required?: boolean;
    displayValue?: (value: any) => JSX.Element;
}): React.JSX.Element;
