"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.showSuccessSnack = showSuccessSnack;
exports.showSnack = showSnack;
exports.hideSnack = hideSnack;
exports.TSnackbarProvider = TSnackbarProvider;
var notistack_1 = require("notistack");
var react_1 = __importDefault(require("react"));
function showSuccessSnack(msg) {
    return showSnack(msg, {
        variant: 'success',
    });
}
function showSnack(msg, options) {
    if (!show)
        throw new Error('missing TSnackbarProvider');
    return show(msg, options);
}
function hideSnack(key) {
    if (!hide)
        throw new Error('missing TSnackbarProvider');
    return hide(key);
}
function TSnackbarProvider(props) {
    return (react_1.default.createElement(notistack_1.SnackbarProvider, { maxSnack: 3, autoHideDuration: 5 * 1000 },
        react_1.default.createElement(TSnackbar, null),
        props.children));
}
var show = null;
var hide = null;
function TSnackbar() {
    var _a = (0, notistack_1.useSnackbar)(), enqueueSnackbar = _a.enqueueSnackbar, closeSnackbar = _a.closeSnackbar;
    show = enqueueSnackbar;
    hide = closeSnackbar;
    return null;
}
